
//import java.io.FileFilter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.awt.BorderLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.ListSelectionModel;

@SuppressWarnings("serial")
class FileTbl extends JFrame {
	private static Viewer JpegViewer = null;
	private static boolean ValidResult = false;			// false:有効な件索結果が無い
	private JPanel contentPane;
	private JTable table;
	private List<FileInfo>	FoundFiles;
	private final static String[] ItemName = { "ファイルパス", "撮影日時", "緯度", "経度", "キャプション", "タグ" };
	private int	RowNo;		// メニューを表示したテーブルの行番号

	static boolean isValidResult() {
		return ValidResult;
	}
	static void setInValid() {
		ValidResult = false;
	}
	
	void AddRow(FileInfo info, String Path, String Day, String Lat, String Lon, String Title, String Tags) {
		TModel.addRow(new String[] {Path, Day, Lat, Lon, Title, Tags});
		FoundFiles.add(info);
		ValidResult = true;
	}
	void setEnable(boolean enable) {
		table.setEnabled(enable);
		super.setEnabled(enable);
	}
	
	class TblModel extends DefaultTableModel {
		String TopFolder;
		TblModel(String[] names, int rows) {
			super(names, rows);
		}
		@Override
		public boolean isCellEditable(int row, int column) {
			return false; // 編集不可
		}
	}
	private TblModel TModel = new TblModel(
			ItemName, 0
	);

	class ActExtViewer extends AbstractAction {
		public ActExtViewer(String title) {
			super(title);
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			String Path = TModel.TopFolder + TModel.getValueAt(RowNo, 0).toString();
			List<String> CmdList = AppWin.Cnf.getpmenuaction0();
			int cnt = CmdList.size();
			String[] CmdStr = new String[cnt];
			for (int i = 0; i < cnt; i++) {
				CmdStr[i] = CmdList.get(i).replace(Config.PathReplace, Path);
			}
			try {
				Runtime.getRuntime().exec(CmdStr);
			}
			catch (IOException ioe) {
			}
		}
	}
	class ActCyberJapan extends AbstractAction {
		public ActCyberJapan(String title) {
			super(title);
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			String Lat = TModel.getValueAt(RowNo, 2).toString();
			String Lon = TModel.getValueAt(RowNo, 3).toString();
			if (Lat.isEmpty() || Lon.isEmpty()) {
				JOptionPane.showMessageDialog(null, "撮影場所の座標情報がありません");
				return;
			}
			String tmp;
			List<String> CmdList = AppWin.Cnf.getpmenuaction1();
			int cnt = CmdList.size();
			String[] CmdStr = new String[cnt];
			for (int i = 0; i < cnt; i++) {
				tmp = CmdList.get(i).replace(Config.LatRepalce, Lat);
				CmdStr[i] = tmp.replace(Config.LonRepalce, Lon);
			}
			try {
				Runtime.getRuntime().exec(CmdStr);
			}
			catch (IOException ioe) {
			}
		}
	}
	class ActGoogleMap extends AbstractAction {
		public ActGoogleMap(String title) {
			super(title);
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			String Lat = TModel.getValueAt(RowNo, 2).toString();
			String Lon = TModel.getValueAt(RowNo, 3).toString();
			if (Lat.isEmpty() || Lon.isEmpty()) {
				JOptionPane.showMessageDialog(null, "撮影場所の座標情報がありません");
				return;
			}
			String tmp;
			List<String> CmdList = AppWin.Cnf.getpmenuaction2();
			int cnt = CmdList.size();
			String[] CmdStr = new String[cnt];
			for (int i = 0; i < cnt; i++) {
				tmp = CmdList.get(i).replace(Config.LatRepalce, Lat);
				CmdStr[i] = tmp.replace(Config.LonRepalce, Lon);
			}
			try {
				Runtime.getRuntime().exec(CmdStr);
			}
			catch (IOException ioe) {
			}
		}
	}
	private JPanel panel;
	private JButton btnNewButton;
	private JButton btnNewButton_1;
	private JPopupMenu PopMenu;
	private JMenuItem menuExtViewer = new JMenuItem("");
	private JMenuItem menuMap0 = new JMenuItem("");
	private JMenuItem menuMap1 = new JMenuItem("");

	// ファイル選択ダイアログを表示し、ファイル名の指定後、データをファイルに保存する
	// 保存されたら true, ダイアログをキャンセル、又は保存に失敗したら false を返す
	private boolean saveData() {
		// 保存ファイルを指定する
		JFileChooser chooser = new JFileChooser();
		FileFilter filter = new FileNameExtensionFilter("CSV file", "csv", "CSV");
		chooser.addChoosableFileFilter(filter);
		chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		chooser.setFileFilter(filter);
		if (chooser.showSaveDialog(this) != JFileChooser.APPROVE_OPTION)
			return false;				// ファイル選択がキャンセルされた
		
		// 指定されたパス名をチェック
		String CSVFilePath = chooser.getSelectedFile().getAbsolutePath();
		if (CSVFilePath.toLowerCase().endsWith(".csv") == false) {
			// 拡張子が ".csv" でない
			CSVFilePath += ".csv";
		}
		File CSVFile = new File(CSVFilePath);
		if (CSVFile.isFile() == true) {
			// 指定されたファイルが存在する
			if (CSVFile.canWrite() == true) {
				// 同名ファイルは上書き可能
				if (JOptionPane.showConfirmDialog(this, "指定されたファイルは存在します。上書きしますか ?",
						"同名ファイルが存在", JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) {
					return false;
				}
			}
			else {
				// 書き換え不可の同名ファイルが存在する
				JOptionPane.showMessageDialog(this, "指定されたファイルは書き換えできません",
						"同名ファイルが存在", JOptionPane.ERROR_MESSAGE);
				return false;
			}
		}
		
		// CSVファイルを出力する
		return WriteCSVData(CSVFilePath);
	}
	
	// saveData() の下請け関数
	// CSV出力用に、','が有れば""で括る。途中の"をエスケープする
	private String quote(String string) {
		// 両端の" + 最大2倍の容量のバッファを用意
		int len = string.length();
		StringBuilder sb = new StringBuilder(2 + len * 2);
		int comma = string.indexOf(',');
		
		if (comma >= 0)
			sb.append('"');			// ','を含む文字列なら先頭に'"'を置く		
		for (int ix = 0; ix < len; ix++) {
			char c = string.charAt(ix);
			if (c == '"')
				sb.append('"');
			sb.append(c);
		}
		if (comma >= 0)
			sb.append('"');			// ','を含む文字列なら末尾に'"'を置く		
		
		return sb.toString();
	}
	
	// 検索結果をFileTblから取り出して、ファイルに書き出す
	private boolean WriteCSVData(String CSVFilePath) {
		PrintStream ps = null;
		try {
			ps = new PrintStream(CSVFilePath);
		
			for (int i = 0; i < ItemName.length; i++) {
				ps.print(ItemName[i]);
				if (i < (ItemName.length - 1))
					ps.print(',');
			}
			ps.println();
					
			int cnt = TModel.getRowCount();
			for (int ix = 0; ix < cnt; ix++) {
				String path		  = quote(TModel.getValueAt(ix, 0).toString());
				String date		  = TModel.getValueAt(ix, 1).toString();
				String latitude	  = TModel.getValueAt(ix, 2).toString();
				String longtitude = TModel.getValueAt(ix, 3).toString();
				String title	  = quote(TModel.getValueAt(ix, 4).toString());
				String tag		  = quote(TModel.getValueAt(ix, 5).toString());
				ps.printf("%1$s,%2$s,%3$s,%4$s,%5$s,%6$s", path, date, latitude, longtitude, title, tag);
				ps.println();
			}
			
			return true;
		}
		catch (FileNotFoundException e) {
			return false;
		}
		finally {
			if (ps != null) {
				ps.close();
			}
		}
	}
	
	// "閉じる" ボタン又は「×」をクリックされたとき
	// 有効なデータが有ればダイアログを表示し、保存するかどうか問い合わせる
	// 「保存」の場合：saveData()を呼び、ファイルに保存する。成功ならtrue, そうでなければfalseを返す
	// 「破棄」の場合：trueを返す
	// 「キャンセル」の場合：falseを返す
	// 有効なデータが無ければtrueを返す
	boolean atClose() {
		int DialogRet;
		String[] option = { "保存", "破棄", "キャンセル" };
		
		if (ValidResult != true)
			return true;			// 有効なデータが無いときは、そのまま戻る
		
		DialogRet = JOptionPane.showOptionDialog(this, "検索結果が保存されていません。\n保存しますか ?","検索結果を保存",
				JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, option, option[0]);
		
		if (DialogRet == JOptionPane.CANCEL_OPTION || DialogRet == JOptionPane.CLOSED_OPTION)
			return false;
		if (DialogRet == JOptionPane.NO_OPTION)
			return true;
		if (DialogRet == JOptionPane.YES_OPTION) {
			return saveData();
		}
		
		return false;
	}
	
	void PopupMenu(MouseEvent e) {
		if (e.isPopupTrigger()) {
			RowNo = table.rowAtPoint(e.getPoint());
			PopMenu.show(e.getComponent(), e.getX(), e.getY());
		}
	}
	/**
	 * Create the frame.
	 */
	FileTbl(String TopFolder) {
		setTitle("検索結果" + " " + TopFolder);
		TModel.TopFolder = TopFolder;
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				if (atClose() == true)
					ValidResult = false;
					dispose();								// ファイルのテーブルを削除
			}
		});
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setSize(700, 300);
		setLocationRelativeTo(null);						// 表示位置を画面中央に設定
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new BorderLayout(0, 0));
		
		table = new JTable();
		table.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() >= 2) {
					if (JpegViewer != null) {
						JpegViewer.dispose();
						JpegViewer = null;
					}
					RowNo = table.getSelectedRow();
					String FileName = TModel.getValueAt(RowNo, 0).toString();
					String FullPath = TModel.TopFolder + FileName;
					FileInfo info = FoundFiles.get(RowNo);
					JpegViewer = new Viewer(FullPath, FileName, info.getWidth(), info.getLines(), info.getOrientation());
				}
			}
			@Override
			public void mousePressed(MouseEvent e) {
				PopupMenu(e);
			}
			@Override
			public void mouseReleased(MouseEvent e) {
				PopupMenu(e);
			}
		});
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		table.setModel(TModel);
		table.setEnabled(false);			// 行選択不可の状態でテーブルを生成
		DefaultTableColumnModel columnModel = (DefaultTableColumnModel)table.getColumnModel();
		columnModel.getColumn(0).setPreferredWidth(260);
		columnModel.getColumn(1).setPreferredWidth(240);
		columnModel.getColumn(2).setPreferredWidth(130);
		columnModel.getColumn(3).setPreferredWidth(130);
		columnModel.getColumn(4).setPreferredWidth(120);
		columnModel.getColumn(5).setPreferredWidth(120);
		JScrollPane sp = new JScrollPane(table);
		contentPane.add(sp);
		
		panel = new JPanel();
		contentPane.add(panel, BorderLayout.SOUTH);
		
		btnNewButton_1 = new JButton("閉じる");
		btnNewButton_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (atClose() == true) {
					ValidResult = false;
					dispose();								// ファイルのテーブルを削除
				}
			}
		});
		panel.add(btnNewButton_1);
		
		btnNewButton = new JButton("ファイルに保存");
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (ValidResult == true) {
					// 有効な検索結果がある場合は、「ファイル保存」ダイアログを表示する
					if (saveData() == true)			// ファイルを保存した
						ValidResult = false;
				}
			}
		});
		panel.add(btnNewButton);
		
		PopMenu = new JPopupMenu();
		menuExtViewer.setAction(new ActExtViewer(AppWin.Cnf.getpmenuTitle0()));
		PopMenu.add(menuExtViewer);
		PopMenu.addSeparator();
		menuMap0.setAction(new ActCyberJapan(AppWin.Cnf.getpmenuTitle1()));
		PopMenu.add(menuMap0);
		menuMap1.setAction(new ActGoogleMap(AppWin.Cnf.getpmenuTitle2()));
		PopMenu.add(menuMap1);
		
		FoundFiles = new ArrayList<FileInfo>();

		setVisible(true);
	}

}