import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.DefaultListModel;
import javax.swing.border.BevelBorder;
import javax.swing.AbstractAction;
import javax.swing.JCheckBox;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;

public class ScrollList {
	private final String TitleMenuAdd = "追加";
	private final String TitleMenuMod = "修正";
	private final String TitleMenuDel = "削除";
	private DefaultListModel<String>	ListModel = new DefaultListModel<String>();
	private JList<String>	list =  new JList<String>(ListModel);
	private JScrollPane		scrollPane = new JScrollPane();
	private JPopupMenu			PopMenu = new JPopupMenu();
	private JMenuItem			menuAdd = new JMenuItem(TitleMenuAdd);
	private JMenuItem			menuMod = new JMenuItem(TitleMenuMod);
	private JMenuItem			menuDel = new JMenuItem(TitleMenuDel);

	@SuppressWarnings("serial")
	class ActmenuAdd extends AbstractAction {
		public ActmenuAdd() {
			super(TitleMenuAdd);
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			String text;
			
			text = JOptionPane.showInputDialog(list, "検索文字列を指定してください");
			if (text == null || text.equals(""))
				return;
			ListModel.addElement(text);
			menuMod.setEnabled(true);
			menuDel.setEnabled(true);			
		}
	}
	
	@SuppressWarnings("serial")
	class ActmenuMod extends AbstractAction {
		public ActmenuMod() {
			super(TitleMenuMod);
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			int SelectedRow;
			String newtext;

			SelectedRow = list.getSelectedIndex();
			if (SelectedRow < 0)
				return;
			newtext = JOptionPane.showInputDialog(list, "検索文字列を修正してください", ListModel.get(SelectedRow));
			if (newtext == null || newtext.equals(""))
				return;
			ListModel.set(SelectedRow, newtext);
		}
	}
	
	@SuppressWarnings("serial")
	class ActmenuDel extends AbstractAction {
		public ActmenuDel() {
			super(TitleMenuDel);
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			int SelectedRow;
			int retval;
			
			SelectedRow = list.getSelectedIndex();
			if (SelectedRow < 0)
				return;
			retval = JOptionPane.showConfirmDialog(list, ListModel.get(SelectedRow) + "を削除します", "項目を削除", JOptionPane.OK_CANCEL_OPTION);
			if (retval == JOptionPane.OK_OPTION)
				ListModel.remove(SelectedRow);
			if (ListModel.getSize() <= 0) {
				menuMod.setEnabled(false);			
				menuDel.setEnabled(false);			
			}
		}
	}
	
	void PopupMenu(MouseEvent e) {
		if (e.isPopupTrigger()) {
			if (list.getSelectedIndex() < 0) {
				menuMod.setEnabled(false);			
				menuDel.setEnabled(false);			
			}
			else {
				menuMod.setEnabled(true);			
				menuDel.setEnabled(true);			
			}
			PopMenu.show(e.getComponent(), e.getX(), e.getY());
		}
	}
	
	List<String> GetList() {
		List<String> tmplist = new ArrayList<String>();
		
		for (int i = 0; i < ListModel.getSize(); i++) {
			tmplist.add((String)ListModel.get(i));
		}
		Collections.sort(tmplist);
		return tmplist;
	}

	ScrollList(JFrame frame, int gridx, int gridy, JCheckBox CheckBox) {
		list.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		list.setEnabled(true);					// 起動時は非アクティブ
		
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.insets = new Insets(0, 0, 5, 5);
		gbc_scrollPane.gridwidth = 5;
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = gridx;
		gbc_scrollPane.gridy = gridy;
		scrollPane.getViewport().setView(list);
		scrollPane.setEnabled(true);
		frame.getContentPane().add(scrollPane, gbc_scrollPane);
		
		menuAdd.setAction(new ActmenuAdd());
		PopMenu.add(menuAdd);	
		menuAdd.setEnabled(true);				// 「追加」メニューは選択可

		menuMod.setAction(new ActmenuMod());
		PopMenu.add(menuMod);
		menuMod.setEnabled(false);				// 「修正」メニューは選択不可

		menuDel.setAction(new ActmenuDel());
		PopMenu.add(menuDel);
		menuDel.setEnabled(false);				// 「削除」メニューは選択不可
		
		MouseListener mouseListener = new MouseAdapter() {
 			@Override
    		public void mouseClicked(MouseEvent e) {
			}
			@Override
			public void mousePressed(MouseEvent e) {
				PopupMenu(e);
			}
			@Override
			public void mouseReleased(MouseEvent e) {
				PopupMenu(e);
			}
     	};
 		list.addMouseListener(mouseListener);
	}
	
	void setEnabled(boolean val) {
		list.setEnabled(val);
	}

}
