import java.awt.Image;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import javax.swing.JFrame;
import java.awt.Rectangle;



@SuppressWarnings("serial")
public class Viewer extends JFrame {
	private Image	JpegImg;
	final static private int	WinWidth_org = 500;	// 標準的な大きさ	幅
	final static private int WinLines_org = 400;	//	〃				高さ
	Rectangle rect;									// 表示領域の矩形
	private int PosX = 0;							// ウィンドウ内の表示位置- X
	private int PosY = 0;							//	〃				   - Y
	private int WinWidth = 0;						// 表示ウィンドウの	幅
	private int WinLines = 0;						//  〃				高さ
	private double radian = 0;						// 回転角
	
	/**
	 * Create the frame.
	 */
	// Orientation	JPEGファイル内での格納状態	ウィンドウサイズの設定方法
	//		1			正立						縦横のサイズはそのまま
	//		2			上下反転						↑
	//		3			倒立							↑
	//		4			上下反転+倒立				↑
	//		5			上下反転+左90°回転		縦横のサイズを入れ替え
	//		6			右90°回転					↑
	//		7			上下反転+右90°回転			↑
	//		8			左90°回転					↑
	//	"反転"はサポートしない
	
	public Viewer(String FullPath, String FilePath, int Width, int Lines, int Orientation) {
		getContentPane().setBackground(Color.LIGHT_GRAY);
		setBackground(Color.LIGHT_GRAY);
		setTitle(FilePath);
		rect = getBounds();
		if (Orientation <= 4) {			// 正立 または 倒立
			WinWidth = WinWidth_org;
			WinLines = WinWidth_org * Lines / Width;
		}
		else {							// 横倒し - 縦横を入れ替え
			WinWidth = WinLines_org;
			WinLines = WinLines_org * Width / Lines;
		}
		getContentPane().setPreferredSize(new Dimension(WinWidth, WinLines));
		pack();
		setResizable(true);
		setVisible(true);
		Insets insets = getInsets();

		if ((Orientation == 3) || (Orientation == 4)) {		// 倒立
			PosX = -WinWidth - insets.left;
			PosY = -WinLines - insets.top;
			// WinWidht, WinLines は変更不要
			radian = Math.PI;
		}
		else if ((Orientation == 5) || (Orientation == 8)) {
			PosX = -WinLines - insets.top;
			PosY = insets.left;
			int tmp = WinWidth;				// 縦横を入れ替え
			WinWidth = WinLines;
			WinLines = tmp;
			radian = -0.5 * Math.PI;
		}
		else if ((Orientation == 6) || (Orientation == 7)) {
			PosX = insets.top; //rect.y;
			PosY = -WinWidth - insets.left;
			int tmp = WinWidth;				// 縦横を入れ替え
			WinWidth = WinLines;
			WinLines = tmp;
			radian = 0.5 * Math.PI;
		}
		else {
			PosX = insets.left;				// 正立の場合
			PosY = insets.top;
			radian = 0;
		}
	
		JpegImg = Toolkit.getDefaultToolkit().getImage(FullPath);
	}
	
	@Override
	public void paint(Graphics g){
		Graphics2D g2 = (Graphics2D)g;
		if (radian != 0)
			g2.rotate(radian);
		g2.drawImage(JpegImg, PosX, PosY, WinWidth, WinLines, this);
	}
}
