import java.io.FileWriter;
import java.io.IOException;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Container;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.Rectangle;



public class Viewer extends JFrame {
	final static private int	WinWidth_org = 500;	// 標準的な大きさ	幅
	final static private int WinLines_org = 400;	//	〃				高さ
	private Image	JpegImg;						// 表示するイメージのデータ
	private int	orient;
	private int PosX = 0;							// ウィンドウ内の表示位置- X
	private int PosY = 0;							//	〃				   - Y
	private int WinWidth = 0;						// 表示ウィンドウの	幅
	private int WinLines = 0;						//  〃				高さ
	private double radian = 0;						// 回転角
	
	/**
	 * Create the frame.
	 */
	// Orientation	JPEGファイル内での格納状態	ウィンドウサイズの設定方法
	//		1			正立						縦横のサイズはそのまま
	//		2			上下反転						↑
	//		3			倒立							↑
	//		4			上下反転+倒立				↑
	//		5			上下反転+左90°回転		縦横のサイズを入れ替え
	//		6			右90°回転					↑
	//		7			上下反転+右90°回転			↑
	//		8			左90°回転					↑
	//	"反転"はサポートしない
	
	// ↓↓↓ デバッグ用
	private FileWriter logwriter;
	private void openlog(String path) {
		try {
			logwriter = new FileWriter(path);
		}	
		catch (IOException e) {
		}
	}
	private void writelog(String log) {
		try {
			logwriter.write(log);
		}
		catch (IOException e) {
		}
	}
	private void closelog() {
		try {
			logwriter.close();
		}
		catch (IOException e) {
		}
	}
	// ↑↑↑ デバッグ用

	
	class ImagePanel extends JPanel {

		@Override
		public void paint(Graphics g){
//			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D)g;
			if (radian != 0)
				g2.rotate(radian);
/*
			if ((orient == 3) || (orient == 4))
				g2.drawImage(JpegImg, -WinWidth, -rect.y - WinLines, WinWidth, WinLines, this);
			else if ((orient == 5) || (orient == 8))
				g2.drawImage(JpegImg, -WinLines, 0, WinLines, WinWidth, this);
			else if ((orient == 6) || (orient == 7))
				g2.drawImage(JpegImg, rect.y, -WinWidth, WinLines, WinWidth, this);
			else
*/
			g2.drawImage(JpegImg, PosX, PosY, WinWidth, WinLines, this);
		}
	}

	public Viewer(String FullPath, String FilePath, int Width, int Lines, int Orientation) {
		Container Pane = getContentPane();
		Pane.setBackground(Color.LIGHT_GRAY);
		setTitle(FilePath);
		ImagePanel Panel = new ImagePanel();
		Pane.add(Panel);
		setResizable(true);
		setVisible(true);
		Insets insets = getInsets();

		orient = Orientation;
		if (orient <= 4) {			// 正立 または 倒立
			WinWidth = WinWidth_org;
			WinLines = WinWidth_org * Lines / Width;
		}
		else {							// 横倒し - 縦横を入れ替え
			WinWidth = WinLines_org;
			WinLines = WinLines_org * Width / Lines;
		}
		// ↓ debgug
/*
		openlog("out.txt");
		writelog(String.format("Rect:height=%1$d, width=%2$d, x=%3$d, y=%4$d\r\n", rect.height, rect.width, rect.x, rect.y));
		Dimension dim = getContentPane().getPreferredSize();
		writelog(String.format("PreferredSize:height=%1$d, width=%2$d\r\n", dim.height, dim.width));
		writelog(String.format("Insets:bottom = %1$d, left = %2$d, right = %3$d, top = %4$d\r\n", insets.bottom, insets.left, insets.right, insets.top));
*/
		// ↑ debug
		if ((orient == 3) || (orient == 4)) {		// 倒立
			PosX = -WinWidth - insets.left;
			PosY = -WinLines - insets.top;
			// WinWidht, WinLines は変更不要
			radian = Math.PI;
		}
		else if ((orient == 5) || (orient == 8)) {
			PosX = -WinLines - insets.top;
			PosY = insets.left;
			int tmp = WinWidth;				// 縦横を入れ替え
			WinWidth = WinLines;
			WinLines = tmp;
			radian = -0.5 * Math.PI;
		}
		else if ((orient == 6) || (orient == 7)) {
			PosX = insets.top; //rect.y;
			PosY = -WinWidth - insets.left;
			int tmp = WinWidth;				// 縦横を入れ替え
			WinWidth = WinLines;
			WinLines = tmp;
			radian = 0.5 * Math.PI;
		}
		else {
			PosX = insets.left;						// 正立の場合
			PosY = insets.top; //rect.y;
			radian = 0;
		}
	
		setSize(WinWidth, WinLines);
		JpegImg = Toolkit.getDefaultToolkit().getImage(FullPath);

		// ↓ debug
/*
		writelog(String.format("WinLines=%1$d, WindWidth=%2$d, PosY=%3$d, PosX=%4$d\r\n", WinLines, WinWidth, PosY, PosX));
		closelog();
*/
		// ↑ debug
	}
	
}
